﻿using Styx.Common;
using System.Windows.Forms;
using System.Windows.Media;
using Styx.WoWInternals;
using System.Diagnostics;

using SB = FmBalance.Core.Helpers.SpellBook;

namespace FmBalance.Core.Managers
{
    class HotKeysManager
    {
        public static bool pauseOn { get; set; }
        public static bool cooldownsOn { get; set; }
		public static bool battlerezOn { get; set;}
        public static bool aoeDots { get; set; }
        public static int saveForBurst { get; set; }
        public static bool keysRegistered { get; set; }
        

        public static void switchKeyValue(int spell)
        {
            switch (spell)
            {
                case SB.SigilOfMisery:
                    aoeDots = !aoeDots;
                    Lua.DoString(@"print('Sigil Of Mistery: \124cFF15E61C Casted!')");
                    break;
                default:
                    break;
            }
        }
        #region [Method] - Hotkey Registration
        public static void registerHotKeys()
        {
            if (keysRegistered)
                return;
            saveForBurst = 0;
			HotkeysManager.Register("battlerezOn", Keys.G, ModifierKeys.Alt, ret =>
            {
                battlerezOn = !battlerezOn;
                Lua.DoString(battlerezOn ? @"print('battlerez: \124cFF15E61C On!')" : @"print('battlerezOn: \124cFFE61515 Off!')");

            });
            HotkeysManager.Register("aoeDots", Keys.S, ModifierKeys.Shift, ret =>
            {
                aoeDots = !aoeDots;
                Lua.DoString(aoeDots ? @"print('Aoe Dots: \124cFF15E61C On!')" : @"print('Aoe Dots: \124cFFE61515 Off!')");

            });
            HotkeysManager.Register("saveForBurst", Keys.S, ModifierKeys.Control, ret =>
            {
                saveForBurst = (saveForBurst+1)%3;
                if(saveForBurst ==0)Lua.DoString(@"print('Save for Burst status: \124cFF15E61C Off')");
                if (saveForBurst == 1) Lua.DoString(@"print('Save for Burst status: \124cFF15E61C Save')");
                if (saveForBurst == 2) Lua.DoString(@"print('Save for Burst status: \124cFF15E61C Burst')");



            });
            HotkeysManager.Register("PauseOn", Keys.Q, ModifierKeys.Alt, ret =>
            {
                pauseOn = !pauseOn;
                Lua.DoString(pauseOn ? @"print('Pause: \124cFF15E61C Enabled!')" : @"print('Pause: \124cFFE61515 Disabled!')");
            });
            HotkeysManager.Register("cooldownsOn", Keys.E, ModifierKeys.Alt, ret =>
            {
                cooldownsOn = !cooldownsOn;
                Lua.DoString(cooldownsOn ? @"print('Cooldowns: \124cFF15E61C Enabled!')" : @"print('Cooldowns: \124cFFE61515 Disabled!')");
            });
            keysRegistered = true;
            Lua.DoString(@"print('Hotkeys: \124cFF15E61C Registered!')");
            Logging.Write(Colors.OrangeRed, "Hotkeys: Registered!");
        }
        #endregion

        #region [Method] - Hotkey Removal
        public static void removeHotkeys()
        {
            if (!keysRegistered)
                return;
			HotkeysManager.Unregister("aoeDots");
            HotkeysManager.Unregister("saveForBurst");
            HotkeysManager.Unregister("battlerezOn");
            HotkeysManager.Unregister("PauseOn");
            HotkeysManager.Unregister("cooldownsOn");
            pauseOn = false;
            cooldownsOn = false;
            keysRegistered = false;
            Lua.DoString(@"print('Hotkeys: \124cFFE61515 Removed!')");
            Logging.Write(Colors.OrangeRed, "Hotkeys: Removed!");
        }
        #endregion
    }
}
