﻿using CommonBehaviors.Actions;
using FmBalance.Core;
using Styx;
using Styx.WoWInternals;
using Styx.WoWInternals.WoWObjects;
using Styx.TreeSharp;
using Styx.CommonBot;
using System.Linq;
using HkM = FmBalance.Core.Managers.HotKeysManager;

namespace FmBalance.Rotation
{
    static class Rotation
    {
        private static LocalPlayer Me { get { return StyxWoW.Me; } }
        private static WoWUnit currentTarget { get { return StyxWoW.Me.CurrentTarget; } }


        #region [Method] - Combat Buffing
        public static Composite combatBuffing()
        {
            return new PrioritySelector(
                new Decorator(ret => !Me.IsAlive || !Me.GotTarget, new ActionAlwaysSucceed()),
                new PrioritySelector()
                );
        }
        #endregion

        #region [Method] - Precombat Buffing
        public static Composite preCombatBuffing()
        {
            return new PrioritySelector(
                new Decorator(ret => !Me.IsAlive || Me.IsCasting || Me.IsChanneling || Me.Mounted || Me.OnTaxi, new ActionAlwaysSucceed()),

                new PrioritySelector(
      
                    
                    ));
        }
        #endregion

        #region [Method] - Rotation Selector

        public static Composite rotationSelector()
        {
            return new PrioritySelector(
                new Decorator(ret => (!Me.IsAlive || !Me.GotTarget), new ActionAlwaysSucceed()),
                new Switch<bool>(ret => HkM.pauseOn,
                    new SwitchArgument<bool>(true,
                        new PrioritySelector(
                        //Nothing Needed
                        //Reserved maybe for Dps Cooldowns?
                        )),

                    new SwitchArgument<bool>(false,
                        new PrioritySelector(
                            "Revive".Cast(reqs => currentTarget.IsFriendly && HkM.battlerezOn),
                            "Starsurge".Cast(reqs => HkM.saveForBurst == 2 ),
                            "New Moon".Cast(reqs => Spell.GetSpellChargeInfo("New Moon").ChargesLeft >2),
                            "Starfall".dropCast(on => currentTarget, ret => HkM.saveForBurst != 1 && Me.CurrentAstralPower >= 80 &&  Unit.UnfriendlyUnitsNearTarget(currentTarget, 15).Count() >= 3),
                            "Starsurge".Cast(reqs => HkM.saveForBurst != 1 && Me.CurrentAstralPower >= 80 ),
                            "Sunfire".Cast(on => Unit.NearbyUnitsInCombatWithUsOrOurStuff.FirstOrDefault(u => u.CurrentHealth > 2000000 && u.GetAuraTimeLeft("Sunfire").TotalSeconds < 1.8 && u.TimeToDeath(int.MaxValue) > 10),reqs=> HkM.aoeDots),
                            "Moonfire".Cast(on => Unit.NearbyUnitsInCombatWithUsOrOurStuff.FirstOrDefault(u => u.CurrentHealth > 2000000 && u.GetAuraTimeLeft("Moonfire").TotalSeconds < 1.8 && u.TimeToDeath(int.MaxValue) > 10), reqs => HkM.aoeDots),
                            "Sunfire".Cast(reqs => currentTarget.GetAuraTimeLeft("Sunfire").TotalSeconds < 1.8 && currentTarget.TimeToDeath(int.MaxValue) > 10 && !HkM.aoeDots ),
                            "Moonfire".Cast(reqs => currentTarget.GetAuraTimeLeft("Moonfire").TotalSeconds < 1.8 && currentTarget.TimeToDeath(int.MaxValue) > 10 && !HkM.aoeDots ),
                            "Berserking".Cast(reqs => HkM.cooldownsOn ),
                            "Incarnation: Chosen of Elune".Cast(reqs => HkM.cooldownsOn ),
                            "New Moon".Cast(),
                            "Starfall".dropCast(on => currentTarget, ret => HkM.saveForBurst != 1 && Unit.UnfriendlyUnitsNearTarget(currentTarget, 15).Count() >= 3 && Me.GetAuraStacks("Lunar Empowerment") < 3 && Me.GetAuraStacks("Solar Empowerment") < 3),
                            "Starsurge".Cast(reqs => HkM.saveForBurst != 1  && Me.GetAuraStacks("Lunar Empowerment") < 3 && Me.GetAuraStacks("Solar Empowerment") < 3),
                            "Lunar Strike".Cast(ret => Me.GetAuraStacks("Lunar Empowerment") > 0  && Unit.UnfriendlyUnitsNearTarget(currentTarget, 15).Count() >= 3),
                            "Solar Wrath".Cast(ret => Me.GetAuraStacks("Solar Empowerment") > 0 ),
                            "Lunar Strike".Cast(ret => Me.GetAuraStacks("Lunar Empowerment") > 0 ),
                            "Lunar Strike".Cast(ret => Unit.UnfriendlyUnitsNearTarget(currentTarget, 15).Count() >= 3),
                            "Solar Wrath".Cast()
                            



                            ))));

        }
        #endregion
    }
}
